
/**
 * Here a dynamical initialisation of a three-dimensional array is done.
 * The value of each element must be become the sum of its indexes.
 * 
 * @author Thomas H. A. Dammann
 * @version $Revision: 1.1 $ --- $Date: 2001/08/23 10:31:09 $
 */


public class ThreeDArray
{

    final int RANG_X            = 3;    // Extension in x direction
    final int RANG_Y            = 5;    // Extension in y direction
    final int RANG_Z            = 4;    // Extension in z direction
    // Create an array with the given extensions
    public int[][][] array3D    = new int[RANG_X][RANG_Y][RANG_Z];

    /**
     * Second example of the lerning unit 3 to show the dynamical initializion of multi-dimensional arrays.
     * */

    public void main()
    {
        int x,      // Index in x direction
            y,      // Index in y direction
            z;      // Index in z direction 

        int count;  // Counts the number of computations

            
        // Initialize counter
        count = 0;

        // Initialize array
        for (x = 0; x < RANG_X; x++)
        {
            for (y = 0; y < RANG_Y; y++)
            {
                for (z = 0; z < RANG_Z; z++)
                {
                    // Assign the sum of the indices
                    array3D[x][y][z] = x + y + z;
                    // Count the number of computations
                    count++;
                }
            }
        }

        // Output the number of computations
        System.out.println("There were "+ count + " computation steps");

        // Print the array
        for (x = 0; x < RANG_X; x++)
        {
            System.out.println("\n2D array for x = " + x);
            for (z = 0; z < RANG_Z; z++)
            {
                for (y = 0; y < RANG_Y; y++)
                {
                    Format.print(System.out,"%3d",array3D[x][y][z]);
                }

                // Print a new line
                System.out.println("");
            }
        }
    }
}
